#!/bin/sh

awk 'BEGIN {

# Header

printf "Map|||Zone|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||Connections||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||\r\n"
printf "||||Type|||||Restrictions||||Player towns|||||Neutral towns|||||Town types|||||||||Minimum mines|||||||Mine Density|||||||Terrain|||||||||Monsters||||||||||||Treasure|||||||||Zones|||||Restrictions|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||\r\n"
printf "Name|Minimum Size|Maximum Size|Id|human start|computer start|Treasure|Junction|Base Size|Minimum human positions|Maximum human positions|Minimum total positions|Maximum total positions|"
printf "Ownership|Minimum towns|Minimum castles|Town Density|Castle Density|"
printf "Minimum towns|Minimum castles|Town Density|Castle Density|"
printf "Towns are of same type|Castle|Rampart|Tower|Inferno|Necropolis|Dungeon|Stronghold|Fortress|Elemental|"
printf "Wood|Mercury|Ore|Sulfur|Crystal|Gems|Gold|"
printf "Wood|Mercury|Ore|Sulfur|Crystal|Gems|Gold|"
printf "Match to town|Dirt|Sand|Grass|Snow|Swamp|Rough|Cave|Lava|"
printf "Strength|Match to town|Neutral|Castle|Rampart|Tower|Inferno|Necropolis|Dungeon|Stronghold|Fortress|"
printf "Forge|Low|High|Density|Low|High|Density|Low|High|Density|"
printf "Zone 1|Zone 2|Value|Wide|Border Guard|"
printf "Minimum human positions|Maximum human positions|Minimum total positions|Maximum total positions|"
printf "|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||\r\n"

time = systime()

# Human Zones

# Number of players with advantage in game
human_count = 2

# This is set to one
player_num = 1

# The maximum number of zones, counting the treasure areas, is 24, because
# HOMM3 appears to have issues if the map has over 48 towns.  The number of
# zones can be increased if the extra fort in zones is disabled.

# Number of areas for a given treasure zone
width = 8
# Number of sets of treasure zone + related areas
height = 2

hub = (width * height) + 1
hubs = height
x = 1
y = 1

# Base size for zones; this determines how big islands can become
size_base = 11

# Place players
for(a = 0; a <= width * height; a++) {
	start[a] = player_num; 
	player_num++
	if(player_num > 8) {
		player_num = 1
	}
}

# Main locations
for(a = 1 ; a <= width * height ; a++) {
	if(start[a] > 0 && start[a] <= human_count) {
		if(a == 1) {
			printf("Samiam %d|16|98|%d|x||||%d|1|8|2|8|", time, a,
			size_base * 3)
		} else {
			printf "|||%d|x||||%d|1|8|2|8|", a, size_base * 3
		} 
		printf "%d||1|||", player_num # One castle
		player_num++
		if(player_num < 1 || player_num > 8) {
			player_num = 1
		}
		# Replace the following with "||||" if you want a lot of zones
		printf "1||||" # One no-fort town (to keep total under 48)
		printf "x|x|x|x|x|x|x|x|x|x|" # Castle type (player choice)
		printf "4|1|4|1|1|1|2|" # Mines 1
		printf "1|1|1|1|1|1|1|" # Mines 2
		printf "x|x|x|x|x|x|x|x|x|" # Terrain type (For town)
		printf "weak||x|x|x|x|x|x|x|x|x|" # Monsters 
		printf "|12000|22000|1|5000|16000|6|300|3000|14|" # Treasure
		printf "%d|%d|", a, hub + (a % hubs) # Connections
		x++
		if(x > width) {
			x = 1
			y++
		}
		printf "15000|||" # Connection guards
		printf "1|8|2|8|" # Number of players
		printf "|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||\r\n"
	} else if(start[a] > 0 && start[a] <= 8) {
	# Non-human start zones
		if(a == 1) {
			printf("Samiam %d|16|98|%d||x|||%d|1|8|2|8|", time, a,
				size_base * 2)
		} else {
			printf "|||%d||x|||%d|1|8|2|8|", a, size_base * 2
		}
		printf "%d|1||||", player_num # One fort
		player_num++
		if(player_num < 1 || player_num > 8) {
			player_num = 1
		}
		# Replace the following with "||||" if you want a lot of zones
		printf "1||||" # One other village (keep total under 48)
		printf "x|x|x|x|x|x|x|x|x|x|" # Any town type is possible
		printf "1|1|1|1|1|1|1|" # Mines 1
		printf "1|1|1|1|1|1|1|" # Mines 2
		printf "x|x|x|x|x|x|x|x|x|" # Terrain type (Any)
		printf "strong||x|x|x|x|x|x|x|x|x|" # Monsters 
		#printf "|4200|8200|1|900|9600|6|30|300|14|" # Treasure
		printf "|12000|22000|1|5000|16000|6|300|3000|14|" # Treasure
		printf "%d|%d|", a, hub + (a % hubs) # Connections
		x++
		if(x > width) {
			x = 1
			y++
		}
		printf "45000|||" # Connection guards
		printf "1|8|2|8|" # Number of players
		printf "|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||\r\n"
	} else { # Treasure island (not presently used)
		if(a == 1) {
			printf("Samiam %d|16|98|%d|||x||%d|1|8|2|8|", time, a,
				size_base * 2)
		} else {
			printf "|||%d|||x||10|1|8|2|8|", a
		}
		printf "|||||" # No owner
		# We need some villages so the nodes will connect to each other
		if(a % 5 == 3) { # Should make random
			printf "||||" # no village
		} else {
			printf "1||||" # one village
		}
		printf "x|x|x|x|x|x|x|x|x|x|" # Any town type is possible
		printf "0|0|0|0|0|0|0|" # Mines 1
		printf "0|0|0|0|0|0|0|" # Mines 2
		printf "|x|x|x|x|x|x|x|x|" # Terrain type (Any)
		printf "strong||x|x|x|x|x|x|x|x|x|" # Monsters 
		#printf "|4200|8200|1|900|9600|6|300|3000|14|" # Treasure
		printf "|12000|22000|1|5000|16000|6|300|3000|14|" # Treasure
		printf "%d|%d|", a, hub + (a % hubs)
		x++
		if(x > width) {
			x = 1
			y++
		}
		printf "45000|||" # Connection guards
		printf "1|8|2|8|" # Number of players
		printf "|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||\r\n"
	} 

}

# Hubs (mega-treasure)
for(a = hub; a < hub + hubs; a++) {
n = a + 1
if (n >= hub + hubs) {
	n = hub
}
printf "|||%d|||x||%d|1|8|2|8|||||||2||||x||||||||x|||||||4||||||||||x|||||||strong||x|x|x|x|x|x|x|x|x||35000|55000|3|25000|35000|10|10000|25000|10|%d|%d|45000|||1|8|2|8||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||\r\n",a,size_base * 4,a,n
}

}' | tr '|' '\t'
